=== debian/changelog ===
openjazz (20260218-1) unstable; urgency=medium

  * Update watch file to Version 5
  * New upstream version 20260218
  * Simplify packaging
  * Bump Standards-Version to 4.7.3, drop redundant Priority and RRR
    fields
  * Bump Debian packaging copyright year

 -- Fabian Greffrath <fabian@debian.org>  Fri, 20 Feb 2026 07:23:47 +0100
