=== debian/control ===
Source: openjazz
Section: contrib/games
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Fabian Greffrath <fabian@debian.org>
Build-Depends:
 asciidoctor,
 cmake,
 debhelper-compat (= 13),
 libsdl2-dev,
 pkgconf,
Standards-Version: 4.7.3
Homepage: https://github.com/AlisterT/openjazz
Vcs-Browser: https://salsa.debian.org/games-team/openjazz
Vcs-Git: https://salsa.debian.org/games-team/openjazz.git

Package: openjazz
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 game-data-packager
Description: Jazz Jackrabbit™ game engine reimplementation
 OpenJazz is a free, open-source version of the classic Jazz Jackrabbit™ games.
 .
 Jazz Jackrabbit™ is a PC platform game. Produced by Epic Games (then Epic
 MegaGames), it was first released in 1994. The fast-paced, colourful gameplay
 proved popular, and the game won PC Format's Arcade Game of the Year award.
 Many people still fondly recall the shareware versions.
 .
 With the demise of DOS-based operating systems, it has become necessary to use
 emulators to play old DOS games. Jazz Jackrabbit™ deserves more - and would
 benefit greatly from new features.
 .
 To play, you will need the files from one of the original games. Current
 releases of `game-data-packager' are able to generate a suitable data package
 from the Jazz Jackrabbit Collection as published on GOG.
