=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND = \
	-DOJ_DATE='"$(shell date --utc --date=@${SOURCE_DATE_EPOCH} +%Y-%m-%d)"' \
	-DOJ_VERSION='"$(DEB_VERSION)"' \
	-UOJ_VERSION_GIT

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_BINDIR=games \
		-DDATAPATH=/usr/share/games/jazz-jackrabbit

execute_after_dh_install:
	sed -e "/^Name/s/$$/ Holiday Hare '95/" \
	    -e "/^Exec/s/$$/ \/usr\/share\/games\/jazz-jackrabbit-hh95/" \
	    -e "$$ a TryExec=/usr/share/games/jazz-jackrabbit-hh95/jazz-jackrabbit" \
	    < $(CURDIR)/res/unix/OpenJazz.desktop \
	    > $(CURDIR)/debian/openjazz/usr/share/applications/OpenJazz-HH95.desktop
