=== debian/watch ===
Version: 5
Template: GitHub
Owner: AlisterT
Project: @PACKAGE@
