## openjazz 20260301

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.18...4.2)
 
 project(OpenJazz
-	VERSION 20260218
+	VERSION 20260301
 	LANGUAGES CXX
 	HOMEPAGE_URL http://alister.eu/jazz/oj/)
 
@@ -78,6 +78,8 @@
 	src/version.cpp
 	src/version.h
 	# episode 1
+	src/jj1/jj1episodeutils.cpp
+	src/jj1/jj1episodeutils.h
 	src/jj1/bonuslevel/jj1bonuslevel.cpp
 	src/jj1/bonuslevel/jj1bonuslevel.h
 	src/jj1/bonuslevel/jj1bonuslevelplayer.cpp
@@ -301,8 +303,7 @@
 	set_property(TARGET OpenJazz PROPERTY LINK_FLAGS
 		"--shell-file ${JS_SHELL} -sMINIFY_HTML=0 -flto --use-port=sdl2
 		 -sFORCE_FILESYSTEM -sEXIT_RUNTIME=1 -sASYNCIFY
-		 -sENVIRONMENT=web --closure 1 -sEXPORTED_RUNTIME_METHODS=['allocate']
-		 -sASSERTIONS -sNO_DISABLE_EXCEPTION_CATCHING")
+		 -sENVIRONMENT=web --closure 1 -sASSERTIONS -sNO_DISABLE_EXCEPTION_CATCHING")
 	set_source_files_properties("src/main.cpp" PROPERTIES OBJECT_DEPENDS "${JS_SHELL}")
 elseif(ANDROID)
 	target_sources(OpenJazz PRIVATE
@@ -412,4 +413,3 @@
 		endforeach()
 		#message("UNRESOLVED_DEPENDENCIES_VAR: ${_u_deps}")
 		]])
-elseif(3DS)
