=== debian/changelog ===
openjazz (20260301-1) unstable; urgency=medium

  * New upstream version 20260301

 -- Fabian Greffrath <fabian@debian.org>  Sun, 01 Mar 2026 09:28:52 +0100
